<template>
    <div>
        <!-- seleccion curso y asig -->
        <form class="tablaForm">
            <table width="80%">
                <tr>
                <td><select @change="changeSelectedCurso" name="Curso" class="selectPerso">
                    <option value="">--Seleccionar Curso--</option>
                    <option v-for="curso in codigosCursos" v-bind:key = curso.id> {{ curso.codigo }} </option>
                </select></td>
                <td><select id="selec_asignatura" @change="changeSelectedAsignatura" name="Asignatura" class="selectPerso">
                    <option value="default">--Seleccionar Asignatura--</option>
                    <option v-for="asignatura in asingaturasCursoSeleccinado" v-bind:key = asignatura> {{ asignatura }} </option>
                </select></td>
                </tr>
            </table>
        </form>
        <!-- fechas planis -->
        <div v-if="asignaturaYCursoSeleccionado" width="1000px" height="1000px">
            <div class="seleccionFecha">
                <table class="tablaFecha">
                    <th class="celda">Fechas de la planificacion</th>
                    <tr><td class="celda"><button @click="verCrono()" class="boton"><span>Ver Cronograma</span></button></td></tr>
                        <tr v-for="planificacion in  planisCronoActual" v-bind:key = planificacion.id>
                            <td class="celda"><button @click="clickPlani(planificacion)">{{planificacion.fechaInicio}} hasta {{planificacion.fechaTermino}}</button><br/></td>
                        </tr>                    
                    <tr><td class="celda"><button @click="newPlani()" class="boton"><span>Nueva Planificacion</span></button></td></tr>
                </table>
            </div>
            <div class="muestraPlanificacion">
                <div id="check" class="panelPlanificacion">
                    <form>
                        <!-- cronograma -->
                        <div v-if="planiSeleccionada == null">
                        <table width="60%">
                            <tr>
                                <td><h4>Fecha Inicial:</h4></td>
                                <td><input  type="date" id="fechaInicial" class="textAreaFecha"/></td>
                                <td><h4>Fecha Final:</h4></td>
                                <td><input type="date" id="fechaInicial" class="textAreaFecha"/></td>                                
                            </tr>
                        </table>
                        <table width="95%">
                            <tr>
                            <td><textarea @change="resetGuardado()" id="cuerpo" v-model="cronogramaActual.descripcion" class="textAreaDescripcion"></textarea></td>
                            </tr>
                        </table>
                        </div>
                        <!-- planificacion -->
                        <div v-else-if="planiSeleccionada != null">
                        <table width="60%">
                            <tr>
                                <td><h4>Fecha Inicial:</h4></td>
                                <td><textarea v-model="planiSeleccionada.fechaInicio"></textarea></td>
                                <td><h4>Fecha Final:</h4></td>
                                <td><textarea v-model="planiSeleccionada.fechaTermino"></textarea></td>
                                <td><h4> </h4></td>
                                <td><button @click="savePlani(planiSeleccionada, $event)" class="botonGuardar"><span>Guardar</span></button></td>
                                <td><h4><textarea readonly v-model="confirmacionPlaniGuardada"></textarea></h4></td>
                            </tr>
                        </table>
                        <table width="95%">
                            <tr>
                            <td><textarea @change="resetGuardado()" id="cuerpo" v-model="planiSeleccionada.descripcion" class="textAreaDescripcion"></textarea></td>
                            <td><tr v-for="evaluacion in planiSeleccionada.evaluaciones" v-bind:key = evaluacion.id>
                            <td class="celda"><button  style="height:40px;width:250px;color:white;background-color:black" disabled>{{evaluacion.nombre}} fecha: {{evaluacion.fecha}}</button><br/></td>                            
                            </tr>
                            <tr><td class="celda"><button @click="newEvaluacion($event)" class="boton"><span>Nueva Evaluacion</span></button></td></tr>
                            </td>
                            </tr>
                        </table>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <div class="botonesNavegacion">
            <botonNavegacion></botonNavegacion>
        </div>
    </div>
</template>

<script setup>
import { Cronograma, Planificacion } from "@/store/index.js";
import { onMounted, ref } from "vue";
import axios from 'axios';
import BotonNavegacion from "./botonNavegacion.vue";

const cursoSeleccionado = ref("--Seleccionar Curso--");
const asignaturaSeleccionada = ref("--Seleccionar Asignatura--");

var _asingaturasCursoSeleccinado = [];
const asingaturasCursoSeleccinado = ref(_asingaturasCursoSeleccinado);
var cod_cursos = [];

const codigosCursos = ref(cod_cursos);

const asignaturaYCursoSeleccionado = ref(false);

const confirmacionPlaniGuardada = ref("");

var _planiSeleccionada = new Planificacion;
const planiSeleccionada = ref(_planiSeleccionada);

var _planisCronoActual = [new Planificacion];
const planisCronoActual = ref(_planisCronoActual);

var _cronogramaActual = new Cronograma;
const cronogramaActual = ref(_cronogramaActual);

const clickPlani = (plani) => {    
    planiSeleccionada.value = plani;
    resetGuardado();
}

const verCrono = () => {
    planiSeleccionada.value = null;
}

const resetGuardado = () => {
    confirmacionPlaniGuardada.value = "";
}

const newEvaluacion = (event) => {
    event.preventDefault();
    var idPlaniSeleccionada = planiSeleccionada.value.id;
    var fecha = planiSeleccionada.value.fechaTermino;
    var numero = 0;
    if(planiSeleccionada.value.evaluaciones != null){
        numero = planiSeleccionada.value.evaluaciones.length + 1;
    }
    axios
      .get("http://localhost:8080/evaluacion/guardar" +      
      "/" + idPlaniSeleccionada + "/" + "prueba_" + numero +
      "/" + fecha + "/60/1/7/100/0",
        {
            headers: {
            'Access-Control-Allow-Origin' : 'http://localhost:8080'
            },
            responseType: "json",
        }
      ).then(red => {
    if(red.data) recargarEvaluaciones();
    });
}

const savePlani = (plani, event) => {
    event.preventDefault();
    var cursoSelecParaPlani = cursoSeleccionado.value;
    var asigSelecParaPlani = asignaturaSeleccionada.value;
    //var planiParaGuardar = JSON.stringify(plani);
    confirmacionPlaniGuardada.value = "Guardando..."
    axios
      .get("http://localhost:8080/planificacion/guardar" +      
      "/" + cursoSelecParaPlani + "/" + asigSelecParaPlani +
      "/" + plani.descripcion + "/" + plani.fechaInicio + "/" + plani.fechaTermino + "/" + plani.id,
        {
            headers: {
            'Access-Control-Allow-Origin' : 'http://localhost:8080'
            },
            responseType: "json",
        }
      ).then(red => {
    if(red.data){
        confirmacionPlaniGuardada.value = "Guardado!";
        recargarPlanis();
    }
    else confirmacionPlaniGuardada.value = "Error al guardar!";
    });
}

const getOneMoreMonth = (fecha) => {
    var month = parseInt(fecha.split("-")[1]) + 1;
    month = (month < 10)?"0" + month: month;
    return fecha.split("-")[0] + "-" + month;
} 

const newPlani = () => {
    var cursoSelecParaPlani = cursoSeleccionado.value;
    var asigSelecParaPlani = asignaturaSeleccionada.value;
    var fechaInicio = "";
    var fechaTermino = "";
    if(cronogramaActual.value.planificaciones.length == 0){
        fechaInicio = cronogramaActual.value.fechaInicio;
        fechaTermino = getOneMoreMonth(fechaInicio);
    }
    else{
        fechaInicio = cronogramaActual.value.planificaciones[cronogramaActual.value.planificaciones.length - 1].fechaTermino;
        fechaTermino = getOneMoreMonth(fechaInicio);
    }
    axios
      .get("http://localhost:8080/planificacion/guardar" +      
      "/" + cursoSelecParaPlani + "/" + asigSelecParaPlani +
      "/" + "descripcion" + "/" + fechaInicio + "/" + fechaTermino + "/0",
        {
            headers: {
            'Access-Control-Allow-Origin' : 'http://localhost:8080'
            },
            responseType: "json",
        }
      ).then(red => {
    if(red.data) recargarEvaluaciones(planiSeleccionada.value);
    });
}

const changeSelectedCurso = (event)=>{
    cursoSeleccionado.value = event.currentTarget.value;
    asingaturasCursoSeleccinado.value = [];
    for (let i = 0; i < codigosCursos.value.length; i++) {
        if(codigosCursos.value[i].codigo == cursoSeleccionado.value){
            for (let j = 0; j < codigosCursos.value[i].asignaturas.length; j++) {
                asingaturasCursoSeleccinado.value.push(codigosCursos.value[i].asignaturas[j].nombre);      
            }
        }
    }
    asignaturaSeleccionada.value = "--Seleccionar Asignatura--";
    asignaturaYCursoSeleccionado.value = false;
    document.getElementById("selec_asignatura").value = 'default';
}

const recargarEvaluaciones = () => {
    var cursoSelecParaCrono = cursoSeleccionado.value;
    var asigSelecParaCrono = asignaturaSeleccionada.value;
    axios
      .get("http://localhost:8080/planificacion/buscar/" + cursoSelecParaCrono + "/" + asigSelecParaCrono, {
        headers: {
          'Access-Control-Allow-Origin' : 'http://localhost:8080'
        },
        responseType: "json",
      }).then(red => {
        cronogramaActual.value = red.data;
        planisCronoActual.value = cronogramaActual.value.planificaciones;
        for (let i = 0; i < planisCronoActual.value.length; i++) {            
            if(planisCronoActual.value[i].id == planiSeleccionada.value.id){
                planiSeleccionada.value = planisCronoActual.value[i];
            }
        }
    });
    if(asignaturaSeleccionada.value != "--Seleccionar Asignatura--") asignaturaYCursoSeleccionado.value = true;
}

const recargarPlanis = ()=>{
    var cursoSelecParaCrono = cursoSeleccionado.value;
    var asigSelecParaCrono = asignaturaSeleccionada.value;
    axios
      .get("http://localhost:8080/planificacion/buscar/" + cursoSelecParaCrono + "/" + asigSelecParaCrono, {
        headers: {
          'Access-Control-Allow-Origin' : 'http://localhost:8080'
        },
        responseType: "json",
      }).then(red => {
        cronogramaActual.value = red.data;
        planisCronoActual.value = cronogramaActual.value.planificaciones;
    });
    if(asignaturaSeleccionada.value != "--Seleccionar Asignatura--") asignaturaYCursoSeleccionado.value = true;
}

const changeSelectedAsignatura = (event)=>{
    asignaturaSeleccionada.value = event.currentTarget.value;
    var cursoSelecParaCrono = cursoSeleccionado.value;
    var asigSelecParaCrono = asignaturaSeleccionada.value;
    axios
      .get("http://localhost:8080/planificacion/buscar/" + cursoSelecParaCrono + "/" + asigSelecParaCrono, {
        headers: {
          'Access-Control-Allow-Origin' : 'http://localhost:8080'
        },
        responseType: "json",
      }).then(red => {
        cronogramaActual.value = red.data;
        planisCronoActual.value = cronogramaActual.value.planificaciones;
    });
    if(asignaturaSeleccionada.value != "--Seleccionar Asignatura--") asignaturaYCursoSeleccionado.value = true;

    if(asignaturaYCursoSeleccionado.value){
        planiSeleccionada.value = null;
    }
}

const getCursos = () => {
    axios
      .get("http://localhost:8080/planificacion/cursos", {
        headers: {
          'Access-Control-Allow-Origin' : 'http://localhost:8080'
        },
        responseType: "json",
      }).then(red => {
    red.data.forEach(c => {codigosCursos.value.push(c)})
    });
    return 0;
}

onMounted(() => {
  getCursos();
});


</script>

<script>
export default {
name: 'selePlani'
}
</script>

<style scoped>
@import '@/assets/Planificacion.css';
</style>